<template>
  <ObModal
    ref="modal"
    :title-second="titleSecond"
    :title="title"
    size="large"
  >
    <ob-form
      class="contract-service-form"
      :form-data="formData"
      :form-model="formModel"
      :is-read-only="!isDraft"
      data-qa="serviceForm"
      @submit="onSubmitHandler"
      :ok-text="isNew ? 'Добавить' : 'Сохранить'"
      cancel-text="Отменить"
    >
      <div class="mb30">
        <ObSelect
          ref="serviceSelect"
          v-if="isNew"
          v-model="formData.serviceDictUuid"
          label="Наименование услуги"
          placeholder="Выберите услугу"
          :display-func="(data) => `${data.title}. ${data.subtitle}`"
          :remote-opt="{
            method: api.contract.getServices,
            loadEvent: 'open',
            arguments: {
              uuid: contract.uuid,
              caste: 'ADDITIONAL'
            }
          }"
          property="serviceDictUuid"
          data-qa="service"
          @selected="onSelectService"
        />
        <ObInput
          v-else
          :value="dataSource.serviceTypeTitle"
          label="Услуга"
          :disabled="true"
        />
      </div>
      <div
        v-if="formData.geography"
        class="nds-row mb30"
      >
        <i class="icon alert" />
        <span>География услуги:</span>
        <span>{{ serviceGeography[formData.geography] }}</span>
      </div>
      <div class="sub-title">
        <span>Налог на добавленную стоимость (НДС)</span>
        <ObTooltip content="НДС">
          <i class="icon question" />
        </ObTooltip>
      </div>
      <ObRadio
        v-if="isNew"
        v-model="formData.isNds"
        label="Не облагается НДС"
        :valueInput="false"
        class="mb10"
        data-qa="isNotNds"
        :disabled="isVatPayer"
        @change="clearNds"
      />
      <ObRadio
        v-model="formData.isNds"
        v-if="isNew"
        label="Облагается НДС"
        :valueInput="true"
        class="mb10"
        data-qa="isNds"
        :disabled="!isVatPayer"
        @change="setDefaultNds"
      />
      <transition name="toggle-height">
        <div
          v-if="formData.isNds || !isNew"
          class="checkbox-input"
          :class="isNew && 'ml25'"
        >
          <ObInput
            v-model="formData.vatRate"
            label="Величина НДС"
            sub-title="%"
            placeholder="Укажите"
            class="input-nds"
            type="number:strict"
            :readonly="true"
            data-qa="vatValue"
          />
          <ObCheckbox
            v-model="formData.isVatInclude"
            label="Тарифы указываются с учётом НДС"
            data-qa="isVatInclude"
            :disabled="!isDraft"
            @change="onChangeIsVatIncluded"
          />
        </div>
      </transition>
      <div class="sub-title mt20">
        Тариф дополнительной услуги
      </div>
      <ObInput
        :value="getTariff('tariff')"
        label="Тариф"
        sub-title="₽"
        placeholder="Укажите"
        type="money:2"
        data-qa="tariff"
        class="tariff-input"
        :readonly="!isDraft"
        @input="onInputTariff('tariff', $event)"
      />
    </ob-form>
  </ObModal>
</template>

<script>
  import { mapGetters } from 'vuex'
  import api from '@/api'
  import FormValidationMixin from 'common-components/src/obComponents/obForm/FormValidationMixin'
  import models from '@/models'
  import cloneDeep from 'clone-deep'
  import ObForm from 'common-components/src/obComponents/obForm'
  import ObInput from 'common-components/src/obComponents/obInput'
  import ObRadio from 'common-components/src/obComponents/obRadio'
  import ObSelect from 'common-components/src/obComponents/obSelect'
  import ObCheckbox from 'common-components/src/obComponents/obCheckbox'
  import ObTooltip from 'common-components/src/obComponents/obTooltip'
  import ObModal from 'common-components/src/obComponents/obModal'
  import debounce from "debounce";

  export default {
    name: 'ContractTransportationФввAdditionalServiceModal',
    components: {
      ObSelect,
      ObInput,
      ObForm,
      ObCheckbox,
      ObRadio,
      ObTooltip,
      ObModal
    },
    mixins: [
      FormValidationMixin
    ],
    props: {
      title: {
        type: String,
        default: ''
      },
      titleSecond: {
        type: String,
        default: ''
      }
    },
    data () {
      return {
        api,
        isNds: true
      }
    },
    computed: {
      ...mapGetters({
        contract: 'contract/contract',
        isDraft: 'contract/isDraft',
        isVatPayer: 'contract/isDoerVatPayer'
      }),
      disabledKeyWords () {
        return this.isNew ? false : !this.dataSource.is_active
      },
      isNew () {
        return !this.dataSource || !this.dataSource.uuid
      },
      formModel () {
        const { vatType = 'NO_VAT', vatRate = 0, isVatInclude = false } = this.dataSource || {}

        if (this.isNew) {
          return models.contract.serviceAdditional({ isVatPayer: this.isVatPayer, caste: 'ADDITIONAL' })
        } else {
          return models.contract.serviceAdditionalEdit({
            isVatPayer: this.isVatPayer,
            vatType,
            vatRate,
            isVatInclude,
            caste: 'ADDITIONAL'
          })
        }
      },
      serviceGeography () {
        return {
          "FROM_TO": "откуда-куда",
          "WHERE": "в точке",
          "WITHOUT_GEOGRAPHY_BINDING": "без привязки"
        }
      }
    },
    methods: {
      afterInitForm () {
        if (this.$refs.serviceSelect) {
          this.$refs.serviceSelect.firstLoad = true
        }
      },
      open () {
        this.$refs.modal.open()
      },
      close () {
        this.$refs.modal.close()
      },
      onSubmitHandler () {
        let data = cloneDeep(this.formData)

        this.$emit('submit', {formData: data, model: this.formModel})
      },
      async clearNds () {
        this.formData.vatRate = 0
        this.formData.vatType = 'NO_VAT'
        await this.calcTariff()
      },
      async setDefaultNds () {
        this.formData.vatRate = this.isVatPayer ? 20 : 0
        this.formData.vatType = this.isVatPayer ? 'TWENTY' : 'NO_VAT'
        await this.calcTariff()
      },
      onSelectService (item) {
        this.formData.contractUuid = this.$route.params.id
        this.formData.serviceDictUuid = item.uuid
        this.formData.serviceUnitUuid = item.serviceUnitUuid
        this.formData.resourceTypeUuid = item.resourceTypeUuid
        this.formData.geography = item.geography
      },
      async onInputTariff (key, value) {
        this.formData[key][this.formData.isVatInclude ? 'priceWithVat' : 'priceWithoutVat'] = value
        await this.calcTariff()
      },
      calcTariff: debounce(async function() {
        let targetKeys = [ 'tariff' ].filter(targetKey => {
          const isExistPrice = this.formData[targetKey]?.priceWithVat || this.formData[targetKey]?.priceWithoutVat
          const isValue = this.formData[targetKey]?.[this.formData.isVatInclude ? 'priceWithVat' : 'priceWithoutVat'] !== undefined
          return isExistPrice && isValue
        })

        let postData = targetKeys.map(targetKey => {
          const priceObject = this.formData.isVatInclude
            ? { priceWithVat: this.formData[targetKey]?.priceWithVat }
            : { priceWithoutVat: this.formData[targetKey]?.priceWithoutVat }
          return {
            vatRate: this.formData.vatRate,
            quantity: 1,
            ...priceObject
          }
        })

        if (this.formData.vatType !== 'NO_VAT') {
          let { itemsList } = await api.orderProcess.vatCalculation({ list: postData })

          targetKeys.forEach((targetKey, index) => {
            const { priceWithVat, priceWithoutVat, vatValue } = itemsList[index]
            this.formData[targetKey].priceWithVat = priceWithVat
            this.formData[targetKey].priceWithoutVat = priceWithoutVat
            this.formData[targetKey].vatPrice = vatValue
          })
        } else {
          targetKeys.forEach(targetKey => {
            this.formData[targetKey].priceWithVat = this.formData[targetKey]?.priceWithoutVat
            this.formData[targetKey].vatPrice = 0
          })
        }
      }, 500),
      onChangeIsVatIncluded () {
        this.$nextTick(() => {
          this.calcTariff()
        })
      },
      getTariff (key) {
        return this.formData.isVatInclude ? this.formData[key]?.priceWithVat : this.formData[key]?.priceWithoutVat
      }
    }
  }
</script>

<style lang='scss' scoped>
  @import '~common-components/src/static/css/mixins';

  .contract-service-form {
    .nds-row {
      width: 100%;
      display: flex;
      align-items: center;
      padding: 20px;
      background-color: $color-white-lilac;
      .icon {
        font-size: 24px;
        color: $color-blue-navy-blue;
      }
      span {
        padding-left: 5px;
        font-size: 14px;
        line-height: 20px;
        color: $color-text-base;
        &:first-of-type {
          padding-left: 20px;
        }
      }
    }

    .main-title {
      @include font-mixin(20px, 28px, 600, $color-text-base, 0.4px);
    }

    .sub-title {
      margin-bottom: 10px;
      @include font-mixin(16px, 24px, 600, $color-text-base, 0.4px);
      .icon {
        margin-left: 3px;
        font-size: 14px;
        font-weight: bold;
        color: $color-grey-span;
      }
    }

    .description {
      margin-bottom: 10px;
      @include font-mixin(12px, 12px, 400, $color-grey-label, 0.4px);
    }

    p {
      @include font-mixin(14px, 18px, 400, $color-grey-label, 0.2px);
    }

    .tariff-input {
      width: 240px;
    }
  }
</style>

<style lang="scss">
  .contract-service-form {
    .mt20 {
      margin-top: 20px!important;
    }

    .mb10 {
      margin-bottom: 10px;
    }

    .mb30 {
      margin-bottom: 30px!important;
    }

    .ml25 {
      margin-left: 25px;
    }

    .checkbox-input {
      display: flex;
      justify-content: flex-start;
      align-items: center;

      .ob-checkbox-container {
        flex-shrink: 0;
        margin-left: 20px;
      }
    }

    .input-nds {
      width: 145px;
    }
  }
</style>
